<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <!-- <title>SonarQube <%= vulnerabilityPhrase %> Report</title> -->
  <style>
    /*
	The sss stylesheet is released under the MIT license.
	<https://github.com/Thiht/sss>
	*/
    <%- stylesheet %>
  </style>
</head>

<body>

  <div class=detail>
    <%if (issues.length> 0) { %>
      <h2>Detail of the Detected <%= vulnerabilityPluralPhrase %>
      </h2>
      <table>
        <thead>
          <tr>
            
            <th>Type</th>
            <th>Rule</th>
            <th>Severity</th>
            <th>Component</th>
            <th>Line</th>

            <th>Text Range</th>
            <th>Description</th>
            <th>Message</th>
            <th class="hidden">Key</th>
            <th>Custom Key</th>
            <th>Status</th>

          </tr>
        </thead>
        <tbody>
          <% for(var i=0; i < issues.length; i++) { %>
            <tr>
              <td>
                  <%= issues[i].type %>
                </a></td>
              <td><a href="<%= sonarBaseURL %>/coding_rules#rule_key=<%= issues[i].rule %>">
                <%= issues[i].rule %>
              </td>
              <td>
                <%= issues[i].severity %>
              </td>
              <td class="component">
                <%= issues[i].component %>
              </td>
              <td>
                <%= issues[i].line %>
              </td>
              <td>
                <%= issues[i].textRange %>
              </td>
              <td>
                <%= issues[i].description %>
              </td>
              <td>
                <%= issues[i].message %>
              </td>
              <td class="hidden">
                <%= issues[i].key %>
              </td>

              <td>
                <%= issues[i].customkey %>
              </td>

              <td><%- issues[i].link(issues[i].status) %></td>
            </tr>
            <% } %>
        </tbody>
      </table>

      <% } %>

        <%if (!noRulesInReport) { %>
          <h3>Known Security Rules</h3>
          <table class="rulestable">
            <thead>
              <tr>
                <th>Rule</th>
                <th>Description</th>
              </tr>
            </thead>
            <tbody>
              <% for (const [ruleKey, rule] of rules) { %>
                <tr>
                  <td><a href="https://next.sonarqube.com/sonarqube/coding_rules#rule_key=<%= ruleKey %>">
                      <%= ruleKey %>
                    </a>
                  </td>
                  <td>
                    <details>
                      <%- rule.htmlDesc %>
                    </details>
                  </td>
                </tr>
                <% } %>
            </tbody>
          </table>
          <% } %>
  </div>

  <%if (issues.length> 0) { %>

    <script>
      var canvas = document.getElementById("vulnerabilitiesPieChart");
      var ctx = canvas.getContext("2d");

      var data = [
      <%= summary.blocker %>,
      <%= summary.critical %>,
      <%= summary.major %>,
      <%= summary.minor %>
    ];
      var total = data.reduce(function (sum, n) {
        return sum + n;
      })
      var colors = ['#2c3e50', '#d43223', '#f39c12', '#319ddb'];

      for (var i = 0, lastend = 0; i < data.length; i++) {
        ctx.fillStyle = colors[i];
        ctx.beginPath();
        ctx.moveTo(canvas.width / 2, canvas.height / 2);
        ctx.arc(canvas.width / 2, canvas.height / 2, canvas.height / 2, lastend, lastend + (Math.PI * 2 * (data[i] /
          total)), false);
        ctx.lineTo(canvas.width / 2, canvas.height / 2);
        ctx.fill();
        lastend += Math.PI * 2 * (data[i] / total);
      }
    </script>

    <% } %>
</body>

</html>